# Programa que calcula el punto de contacto
# en la elipse que es ortogonal a la línea que
# une el punto dado con el punto calculado
# Fraga 11.07.2022
#
import numpy as np
import sys
import math

n = len( sys.argv )
if n != 3:
	print( "Args: x y" )
	sys.exit(1)

a = 4
b = 2
x = float( sys.argv[1] ) 
y = float( sys.argv[2] ) 

b2 = b*b
a2 = a*a

# Valores iniciales:
vxk1 = np.array( [[x], [y]] )
v = a*b/math.sqrt(b2*x*x + a2*y*y)
vxk1 *= v

vxk2 = np.zeros( (2, 1) )
if math.fabs( x ) < a :
	vxk2[0,0] = x
	vxk2[1,0] = math.sqrt(a2-x*x)*b/a
	if y < 0:
		vxk2[1,0] = -vxk2[1,0] 
else :
	vxk2[0,0] = a
	if x <= 0 :
		vxk2[0,0] = -vxk2[0,0]

# print( vxk1.shape )
# print( vxk2.shape )
vx0 = (vxk1 + vxk2)/2
# print( vx0.shape )

# El Newton que resuelve el problema
imax = 20

print( "0", vx0 )

vxi = np.zeros( (2, 1) )
vf = np.zeros( (2, 1) )
Q = np.zeros( (2,2) )
Qi = np.zeros( (2,2) )
i=1
while i <= imax :
	Q[0,0] = b2*vx0[0,0]
	Q[0,1] = a2*vx0[1,0]
	Q[1,0] = (a2-b2)*vx0[1,0] + b2*y
	Q[1,1] = (a2-b2)*vx0[0,0] - a2*x

	# Se invierte Q usando determinantes
	d = Q[0,0]*Q[1,1] - Q[0,1]*Q[1,0]
	Qi[0,0] = Q[1,1]/d
	Qi[0,1] = -Q[0,1]/d
	Qi[1,0] = -Q[1,0]/d
	Qi[1,1] = Q[0,0]/d

	# Se calcula el vector f
	vf[0,0] = (a2*vx0[1,0]*vx0[1,0] + b2*vx0[0,0]*vx0[0,0] - a2*b2)/2.0
	vf[1,0] = b2*vx0[0,0]*(y - vx0[1,0]) - a2*vx0[1,0]*(x - vx0[0,0])

	vxi = vx0 - Qi @ vf

	print( i, vxi )

	vv = vxi - vx0
	v = vv.T @ vv
	if v < 1e-12 :
		break

	vx0 = vxi

	i += 1
